stages:
    - build
    - test
    - release
    - deploy

image: maven

build application:
    stage: build
    script:
        - echo "Build application version ${CI_COMMIT_REF_SLUG} at ${CI_COMMIT_SHORT_SHA} commit"
        - mvn compile
        - echo 'building successful'

test on docker:
    stage: test
    script:
        - echo "Test ${CI_JOB_ID}"
        - mvn test
    tags:
        - docker

test on shell:
    stage: test
    script:
        - echo "Test ${CI_JOB_ID}"
        - mvn test
    tags:
        - linux

release:
    stage: release
    script:
      - mvn package
      - ls -la
    artifacts:
      paths:
        - /builds/deusops/lessons/git-lesson/target/maigolab_hello-1.0.0.jar
      expire_in: 1 week

deploy to dev:
    stage: deploy
    script:
        - echo 'deploying to dev...'
    when: manual

deploy to prod:
    stage: deploy
    script:
        - echo 'deploying to prod...'
    when: manual
    only:
      refs:
        - master
        - tags
